;
; VV_DEMO
;
; VecVoice demo/example program
;
;
; Copyright (c) Alex Herbert 2002
;



;
; Memory segments
;

        bss
        org     $c880

        code
        org     $0000


;
; 6522 registers
;

CNTRL   equ     $d000
DAC     equ     $d001
DDAC    equ     $d003
T1LOLC  equ     $d004
ACNTRL  equ     $d00b
IFLAG   equ     $d00d


;
; Executive ROM routines
;

FRWAIT  equ     $f192
INPUT   equ     $f1ba


;
; Executive variables
;

EDGE    equ     $c811



;
; Cartridge header
;

        db      "g GCE     ",$80
        dw      null_music
        db      $00


;
; Program execution starts here... 
;


main
        jsr     vv_init         ; VecVoice: initialize variables
                                ; (must be called once at start)

main_loop
        jsr     FRWAIT          ; sync to frame timer

        jsr     INPUT           ; read joystick buttons

        jsr     vv_speak        ; VecVoice: output allophones
                                ; (must be called in main loop,
                                ; once per frame, after reading
                                ; joystick buttons.)


        lda     EDGE            ; get button edges

check_button1
        bita    #$01            ; button 1 pressed?
        beq     check_button2   ; if not, check button 2

        ldx     #demo_string1
        stx     vv_addr         ; start speaking demo_string1

        bra     main_loop


check_button2
        bita    #$02            ; button 2 pressed?
        beq     check_button3   ; if not, check button 3

        ldx     #demo_string2
        stx     vv_addr         ; start speaking demo_string2

        bra     main_loop


check_button3
        bita    #$04            ; button 3 pressed?
        beq     check_button4   ; if not, check button 4

        ldx     #demo_string3
        stx     vv_addr         ; start speaking demo_string3

        bra     main_loop


check_button4
        bita    #$08            ; button 4 pressed?
        beq     main_loop       ; if not, then loop

        ldx     #demo_string4
        stx     vv_addr         ; start speaking demo_string4

        bra     main_loop




demo_string1
        db      VV_WW,VV_AX,VV_NN1,VV_PA3,VV_TERM       ; "One"

demo_string2
        db      VV_TT2,VV_UW2,VV_PA3,VV_TERM            ; "Two"

demo_string3
        db      VV_TH,VV_RR1,VV_IY,VV_PA3,VV_TERM       ; "Three"

demo_string4
        db      VV_FF,VV_OR,VV_PA3,VV_TERM              ; "Four"



;
; Include the VecVoice driver
;

        include "VECVOICE.I"


;
; Title music
; 

null_music
        dw      $0000
        dw      $0000
        db      $00,$80



